package com.usky.system.service.util;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

/**
 * @description: 异步任务管理器
 * @author: XiaoYu
 * @date: 2024/08/20 13:58
 */
@Component
public class AsyncManager {

    private static final Logger logger = LoggerFactory.getLogger(AsyncManager.class);

    /**
     * 异步操作任务调度线程池
     */

    private static final ThreadPoolExecutor executorEvent = new ThreadPoolExecutor(
            20, 30, 0L, TimeUnit.MILLISECONDS,
            new ArrayBlockingQueue<Runnable>(1024),
            new ThreadPoolExecutor.AbortPolicy()
    );


    public void insertLog(Integer tenantId, final String username, final String status, final String message, final Integer deptId) {
        ServletRequestAttributes sra = (ServletRequestAttributes) RequestContextHolder.getRequestAttributes();
        RequestContextHolder.setRequestAttributes(sra, true);
        executorEvent.execute(() -> {
            logger.info("new Log is {} , {}", username, message);
            AsyncFactory.recordLoginInfo(tenantId, username, status, message, deptId);
        });
    }


}

